//Arduino Uno 433 MHZ RF receiver code
#include <VirtualWire.h>
#include <LiquidCrystal_I2C.h>
//Initialise the LCD 1602 I2C
LiquidCrystal_I2C lcd(0x3F, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);
const int transmit_pin = 11;
const int receive_pin = 12;
const int transmit_en_pin = 3;
char temperaturecChar[10];
char temperaturefChar[10];
struct package
{
  float temperatureC = 0.0;
  float temperatureF = 0.0;
};
typedef struct package Package;
Package data;

void setup()
{
  Serial.begin(9600);
  //initialise the IO and ISR
  vw_set_tx_pin(transmit_pin);
  vw_set_rx_pin(receive_pin);
  vw_set_ptt_pin(transmit_en_pin);
  vw_set_ptt_inverted(true); // Required for DR3100
  vw_setup(500);  // Bits per sec
  vw_rx_start();       // Start the receiver PLL running
  //define the LCD as 16 column by 2 rows
  lcd.begin (16, 2);
  //switch on the backlight
  lcd.setBacklightPin(3, POSITIVE);
  lcd.setBacklight(HIGH);
  //goto first column (column 0) and first line (Line 0)
  lcd.setCursor(0, 0);
  //Print at cursor Location
  lcd.print("433 MHZ RF TX/RX");
  //goto first column (column 0) and second line (line 1)
  lcd.setCursor(0, 1);
  lcd.print("by Acoptex.com");
  delay (3000);
  lcd.clear();// clears screen
}

void loop()
{
  uint8_t buf[sizeof(data)];
  uint8_t buflen = sizeof(data);
  if (vw_have_message())  // Is there a packet for us?
  {
    vw_get_message(buf, &buflen);
    memcpy(&data, &buf, buflen);
    Serial.print("Temperature Celsius: ");
    Serial.print(data.temperatureC);
    Serial.print("*C ");
    String temperaturecString = String(data.temperatureC, 1);
    temperaturecString.toCharArray(temperaturecChar, 10);
    String temperaturefString = String(data.temperatureF, 1);
    temperaturefString.toCharArray(temperaturefChar, 10);
    Serial.print("Temperature Fahrenheit: ");
    Serial.print(data.temperatureF);
    Serial.println("*F ");
    DisplayData();
  }
}
void DisplayData()
{
  //goto first column (column 0) and first line (Line 0)
  lcd.setCursor(0, 0);
  //Print at cursor Location
  lcd.print("Temp: ");
  //goto first column (column 0) and second line (line 1)
  lcd.setCursor(0, 1);
  lcd.print("Temp: ");
  //goto first column (column 7) and second line (line 0)
  lcd.setCursor(7, 0);
  lcd.print(data.temperatureC);
  //goto first column (column 7) and second line (line 1)
  lcd.setCursor(7, 1);
  lcd.print(data.temperatureF);
  //goto first column (column 12) and first line (Line 0)
  lcd.setCursor(13, 0);
  //Print at cursor Location
  lcd.print(" *C");
  //goto first column (column 12) and second line (line 1)
  lcd.setCursor(13, 1);
  lcd.print(" *F");
}
